/*
#   conctact : carrilho_joakim@yahoo.fr
#   license MIT 
#
# == BEGIN LICENSE ==
#
# Copyright (C) 2008 Carrilho de Almeida Joakim 
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
#== END LICENSE == 
*/


/*-----------------------------public-----------------------------------*/


var $abstract=function(_class,superclass){//fonction ki initialise une classe abstraite
   var Klass;
   _class.subclasses = [];//tableau des sous classe
   if(superclass){//voire definition des mthode 
      _class.addMethod=Kernel.addMethod;
      Kernel.initializeExtend(_class,superclass);
      Klass=Kernel.extend(_class,superclass.prototype || superclass);
      Kernel.addMethods(_class,Klass);
      Klass.$super=Kernel.$super;
   }
   return  Klass || _class;   
}


var $class=function(_class,superclass){//fonction ki initialise une classe 
   var Klass,i;
   Klass=function(){
      return this.constructor.apply(this,arguments);//on retourne le constructeur
   }
   Klass.subclasses = [];//creer un tableau en static , pour les classe futur, ki hriteront d'elle
   if(superclass){
      Kernel.initializeExtend(Klass,superclass);
      Klass.prototype=Kernel.clone(superclass.prototype || superclass); 
      Kernel.addMethods(_class,Klass);  
      Klass.prototype.$super=Kernel.$super; 
   }else
      Klass.prototype=_class;
   if(_class.$static)//recopie les proprit static si dfinit
       for(i in _class.$static)
          Klass[i]=_class.$static[i];
   Klass.prototype.$static=Klass;       
   return Klass;
};

/*----------------------------------priv-----------------------------------*/
Kernel={
   clone : function(source){//clone un objet en passant par le prototype, comme ca si j amais on modifie la source alors le clone aussi, la rciproque n'tant pas vrai
      var temp=function(){};
      temp.prototype=source;
      return new temp();
   },
   extend : function(source,destination){//tend un objet en clonant la source et rajout les proprit sur l objet clon
      var toReturn,i;
      toReturn=Kernel.clone(destination);
      for(i in source)
         if(!toReturn[i])
            toReturn[i]=source[i];
      return toReturn;
   },
   addMethod : function(property,value){//ajoute en proprit de l'objet de type fonction , le nom de la fonction dans l'objet + la rference de la super class dont hrite la mthode
      if(typeof value=='function' && this.superclass){
         value.superclass=this.superclass.prototype || this.superclass; 
         value.property=property; 
      }
      (this.prototype || this)[property] = value;
      return this;
   },
   addMethods : function(source,destination){//boucle ki ajoute les mthode,pour toute les proprit de l'objet non tendue (sans celle hrit)
      for(var i in source)//ajoute les mthode de la classe
         if(i!='$static')
            destination.addMethod(i,source[i]);
   }, 
   $super : function(){//fonction permettant d'appeller la superclass de la fonction, 1er agument la string de la prorpit,2eme tableau a pass en argument via apply  !! si la tring de la proprit a recherch n 'est pas dfinit, alors elle sera automatiquement atribu du meme nom que celle ki l'appele , diffrent du java, ki si on lui passe rien appelle le constructeur.... pour moi plus logique , a voire
      var args,superclass,get,caller,id;
      caller=arguments.callee.caller;//rcupere la fonction ki a appell le super
      if(typeof arguments[0]=='string'){
         id=arguments[0];
         args=arguments[1];
      }else{
         id=caller.property;
         args=arguments[0];
      }
      get=caller.superclass[id];
      if(typeof get=='function')
         return  get.apply(this,args);
      return get;
   },
   initializeExtend : function(Klass,superclass){//ajoute la mthode d'ajout de methode + definit superclass et ajoute une la class dans le tableau de sa superclass, ki rcapitulise toute les sousclasses
      Klass.addMethod=Kernel.addMethod;
      Klass.superclass = superclass;
      superclass.subclasses=[Klass];
   }
};
